#include <Python.h>
#include "quake2ai.h"


static PyObject *
q2ai_setargs(PyObject *self, PyObject *args)
{
    char *command;
    if (!PyArg_ParseTuple(args, "s", &command))
        return NULL;
    quake2ai_setargs(command);
    return Py_BuildValue("i", 1);
}


static PyObject *
q2ai_launch(PyObject *self, PyObject *args)
{
	quake2ai_launch ();
    return Py_BuildValue("i", 0);
}

static PyObject *
q2ai_AIself_name(PyObject *self, PyObject *args)
{
	return Py_BuildValue("s", AIself_name());	
}

static PyObject *
q2ai_AIself_health(PyObject *self, PyObject *args)
{
	return Py_BuildValue("i", AIself_health());	
}

static PyObject *
q2ai_AIself_armor(PyObject *self, PyObject *args)
{
	return Py_BuildValue("i", AIself_armor());	
}

static PyObject *
q2ai_AIself_ammo(PyObject *self, PyObject *args)
{
	return Py_BuildValue("i", AIself_ammo());	
}

static PyObject *
q2ai_AIself_frags(PyObject *self, PyObject *args)
{
	return Py_BuildValue("i", AIself_frags());	
}

static PyObject *
q2ai_AIself_x(PyObject *self, PyObject *args)
{
	return Py_BuildValue("d", AIself_x());	
}
static PyObject *
q2ai_AIself_y(PyObject *self, PyObject *args)
{
	return Py_BuildValue("d", AIself_y());	
}
static PyObject *
q2ai_AIself_z(PyObject *self, PyObject *args)
{
	return Py_BuildValue("d", AIself_z());	
}
static PyObject *
q2ai_AIself_xvel(PyObject *self, PyObject *args)
{
	return Py_BuildValue("d", AIself_xvel());	
}
static PyObject *
q2ai_AIself_yvel(PyObject *self, PyObject *args)
{
	return Py_BuildValue("d", AIself_yvel());	
}
static PyObject *
q2ai_AIself_zvel(PyObject *self, PyObject *args)
{
	return Py_BuildValue("d", AIself_zvel());	
}


static PyObject *
q2ai_AIself_forwardmove(PyObject *self, PyObject *args)
{
	float val;
	PyArg_ParseTuple(args, "d", &val);	
	AIself_forwardmove(val);	
    Py_INCREF(Py_None);
	return Py_None;
}
static PyObject *
q2ai_AIself_sidemove(PyObject *self, PyObject *args)
{
	float val;
	PyArg_ParseTuple(args, "d", &val);	
	AIself_sidemove(val);	
    Py_INCREF(Py_None);
	return Py_None;
}
static PyObject *
q2ai_AIself_upmove(PyObject *self, PyObject *args)
{
	float val;
	PyArg_ParseTuple(args, "d", &val);	
	AIself_upmove(val);	
    Py_INCREF(Py_None);
	return Py_None;
}
static PyObject *
q2ai_AIself_attack(PyObject *self, PyObject *args)
{
	int val;
	PyArg_ParseTuple(args, "i", &val);	
	AIself_attack(val);	
    Py_INCREF(Py_None);
	return Py_None;
}
static PyObject *
q2ai_AIself_yawmove(PyObject *self, PyObject *args)
{
	double val;
	PyArg_ParseTuple(args, "d", &val);	
	AIself_yawmove(val);	
    Py_INCREF(Py_None);
	return Py_None;
}
static PyObject *
q2ai_AIself_setyaw(PyObject *self, PyObject *args)
{
	double val;
	PyArg_ParseTuple(args, "d", &val);	
	AIself_setyaw(val);	
    Py_INCREF(Py_None);
	return Py_None;
}

static PyObject *
q2ai_AIself_yaw(PyObject *self, PyObject *args)
{
	return Py_BuildValue("d", AIself_yaw());	
}

static PyObject *
q2ai_AIself_pitchmove(PyObject *self, PyObject *args)
{
	double val;
	PyArg_ParseTuple(args, "d", &val);	
	AIself_pitchmove(val);	
    Py_INCREF(Py_None);
	return Py_None;
}
static PyObject *
q2ai_AIself_setpitch(PyObject *self, PyObject *args)
{
	double val;
	PyArg_ParseTuple(args, "d", &val);	
	AIself_setpitch(val);	
    Py_INCREF(Py_None);
	return Py_None;
}
static PyObject *
q2ai_AIself_pitch(PyObject *self, PyObject *args)
{
	return Py_BuildValue("d", AIself_pitch());	
}

static PyObject *
q2ai_AIentity_exists(PyObject *self, PyObject *args)
{
	int val;
	PyArg_ParseTuple(args, "i", &val);	
	return Py_BuildValue("i", AIentity_exists(val));	
}
static PyObject *
q2ai_AIentity_model(PyObject *self, PyObject *args)
{
	int val;
	PyArg_ParseTuple(args, "i", &val);	
	return Py_BuildValue("s", AIentity_model(val));	
}
static PyObject *
q2ai_AIentity_x(PyObject *self, PyObject *args)
{
	int val;
	PyArg_ParseTuple(args, "i", &val);	
	return Py_BuildValue("d", AIentity_x(val));	
}
static PyObject *
q2ai_AIentity_y(PyObject *self, PyObject *args)
{
	int val;
	PyArg_ParseTuple(args, "i", &val);	
	return Py_BuildValue("d", AIentity_y(val));	
}
static PyObject *
q2ai_AIentity_z(PyObject *self, PyObject *args)
{
	int val;
	PyArg_ParseTuple(args, "i", &val);	
	return Py_BuildValue("d", AIentity_z(val));	
}
static PyObject *
q2ai_AIentity_pitch(PyObject *self, PyObject *args)
{
	int val;
	PyArg_ParseTuple(args, "i", &val);	
	return Py_BuildValue("d", AIentity_pitch(val));	
}
static PyObject *
q2ai_AIentity_yaw(PyObject *self, PyObject *args)
{
	int val;
	PyArg_ParseTuple(args, "i", &val);	
	return Py_BuildValue("d", AIentity_yaw(val));	
}
static PyObject *
q2ai_AIentity_frame(PyObject *self, PyObject *args)
{
	int val;
	PyArg_ParseTuple(args, "i", &val);	
	return Py_BuildValue("i", AIentity_frame(val));	
}


static PyObject *
q2ai_AIview_width(PyObject *self, PyObject *args)
{
	return Py_BuildValue("i", AIview_width());	
}
static PyObject *
q2ai_AIview_height(PyObject *self, PyObject *args)
{
	return Py_BuildValue("i", AIview_height());	
}
static PyObject *
q2ai_AIview_pixel(PyObject *self, PyObject *args)
{
	int val0, val1;
	PyArg_ParseTuple(args, "ii", &val0, &val1);	
	return Py_BuildValue("i", AIview_pixel(val0, val1));	
}
static PyObject *
q2ai_AIview_block(PyObject *self, PyObject *args)
{
	int x, y, w, h;
	PyArg_ParseTuple(args, "iiii", &x, &y, &w, &h);	
	return Py_BuildValue("i", AIview_block(x, y, w, h));	
}
static PyObject *
q2ai_red(PyObject *self, PyObject *args)
{
	int val;
	PyArg_ParseTuple(args, "i", &val);	
	return Py_BuildValue("i", red(val));	
}
static PyObject *
q2ai_green(PyObject *self, PyObject *args)
{
	int val;
	PyArg_ParseTuple(args, "i", &val);	
	return Py_BuildValue("i", green(val));	
}
static PyObject *
q2ai_blue(PyObject *self, PyObject *args)
{
	int val;
	PyArg_ParseTuple(args, "i", &val);	
	return Py_BuildValue("i", blue(val));	
}
static PyObject *
q2ai_AI_talk(PyObject *self, PyObject *args)
{
	char* val;
	PyArg_ParseTuple(args, "s", &val);	
	AI_talk(val);
    Py_INCREF(Py_None);
	return Py_None;	
}
static PyObject *
q2ai_AI_teamtalk(PyObject *self, PyObject *args)
{
	char* val;
	PyArg_ParseTuple(args, "s", &val);	
	AI_teamtalk(val);
    Py_INCREF(Py_None);
	return Py_None;	
}

static PyObject *
q2ai_AI_command(PyObject *self, PyObject *args)
{
	char* val;
	PyArg_ParseTuple(args, "s", &val);	
	AI_command(val);
    Py_INCREF(Py_None);
	return Py_None;	
}
static PyObject *
q2ai_AImsg_body(PyObject *self, PyObject *args)
{
	int val;
	PyArg_ParseTuple(args, "i", &val);	
	return Py_BuildValue("s", AImsg_body(val));	
}
static PyObject *
q2ai_AImsg_type(PyObject *self, PyObject *args)
{
	int val;
	PyArg_ParseTuple(args, "i", &val);	
	return Py_BuildValue("i", AImsg_type(val));	
}
static PyObject *
q2ai_anglediff(PyObject *self, PyObject *args)
{
	double val0, val1;
	PyArg_ParseTuple(args, "dd", &val0, &val1);	
	return Py_BuildValue("d", anglediff(val0, val1));	
}
static PyObject *
q2ai_angleadd(PyObject *self, PyObject *args)
{
	double val0, val1;
	PyArg_ParseTuple(args, "dd", &val0, &val1);	
	return Py_BuildValue("d", angleadd(val0, val1));	
}
static PyObject *
q2ai_dist(PyObject *self, PyObject *args)
{
	double val0, val1, val2, val3;
	PyArg_ParseTuple(args, "dddd", &val0, &val1, &val2, &val3);	
	return Py_BuildValue("d", dist(val0, val1, val2, val3));	
}
static PyObject *
q2ai_xdir(PyObject *self, PyObject *args)
{
	double val0, val1, val2, val3;
	PyArg_ParseTuple(args, "dddd", &val0, &val1, &val2, &val3);	
	return Py_BuildValue("d", xdir(val0, val1, val2, val3));	
}
static PyObject *
q2ai_rad(PyObject *self, PyObject *args)
{
	double val;
	PyArg_ParseTuple(args, "d", &val);	
	return Py_BuildValue("d", rad(val));	
}
static PyObject *
q2ai_deg(PyObject *self, PyObject *args)
{
	double val;
	PyArg_ParseTuple(args, "d", &val);
	return Py_BuildValue("d", deg(val));
}

static PyObject *
q2ai_trace(PyObject *self, PyObject *args)
{
	float val1, val2, val3, val4, val5, val6, val7;
	PyArg_ParseTuple(args, "fffffff", &val1, &val2, &val3, &val4, &val5, &val6, &val7);	
	AItrace(val1, val2, val3, val4, val5, val6, val7);	
    Py_INCREF(Py_None);
	return Py_None;
}
static PyObject *
q2ai_traced_endpoint_x (PyObject *self, PyObject *args)
{
	return Py_BuildValue("f", AItraced_endpoint_x());
}
static PyObject *
q2ai_traced_endpoint_y (PyObject *self, PyObject *args)
{
	return Py_BuildValue("f", AItraced_endpoint_y());
}
static PyObject *
q2ai_traced_endpoint_z (PyObject *self, PyObject *args)
{
	return Py_BuildValue("f", AItraced_endpoint_z());
}
static PyObject *
q2ai_traced_fraction (PyObject *self, PyObject *args)
{
	return Py_BuildValue("f", AItraced_fraction());
}

static PyObject *AImain_callback = NULL;

static PyObject *
q2ai_set_AImain(PyObject *dummy, PyObject *args)
{
    PyObject *result = NULL;
    PyObject *temp;

    if (PyArg_ParseTuple(args, "O", &temp)) {
        if (!PyCallable_Check(temp)) {
			printf("BIG ERROR\n");
            PyErr_SetString(PyExc_TypeError, "parameter must be callable");
            return NULL;
        }
		printf("You did it!\n");
        Py_XINCREF(temp);         /* Add a reference to new callback */
        Py_XDECREF(AImain_callback);  /* Dispose of previous callback */
        AImain_callback = temp;       /* Remember new callback */
        /* Boilerplate to return "None" */
        Py_INCREF(Py_None);
        result = Py_None;
    }
    return result;
}

static PyObject *
q2ai_call_AImain(PyObject *self, PyObject *args)
{
	PyObject *arglist = Py_BuildValue("");
	
	if (AImain_callback == NULL)
		printf("It's NULL\n");
	else {
		printf("working %x\n", (unsigned int)AImain_callback);
		PyEval_CallObject(AImain_callback, arglist);
	}
    Py_INCREF(Py_None);
	return Py_None;
}

static PyMethodDef q2aiMethods[] = 
{
    { "setargs", q2ai_setargs, METH_VARARGS, 
      "setargs(string)->int"},
    { "launch", q2ai_launch, METH_VARARGS, 
      "launch()->int"},

    { "self_name", q2ai_AIself_name, METH_VARARGS, 
      "self_name()->string"},
    { "self_health", q2ai_AIself_health, METH_VARARGS, 
      "self_health()->int"},
    { "self_armor", q2ai_AIself_armor, METH_VARARGS, 
      "self_armor()->int"},
    { "self_ammo", q2ai_AIself_ammo, METH_VARARGS, 
      "self_ammo()->int"},
    { "self_frags", q2ai_AIself_frags, METH_VARARGS, 
      "self_frags()->int"},

    { "self_x", q2ai_AIself_x, METH_VARARGS, 
      "self_x()->double"},
    { "self_y", q2ai_AIself_y, METH_VARARGS, 
      "self_y()->double"},
    { "self_z", q2ai_AIself_z, METH_VARARGS, 
      "self_z()->double"},
    { "self_xvel", q2ai_AIself_xvel, METH_VARARGS, 
      "self_xvel()->double"},
    { "self_yvel", q2ai_AIself_yvel, METH_VARARGS, 
      "self_yvel()->double"},
    { "self_zvel", q2ai_AIself_zvel, METH_VARARGS, 
      "self_zvel()->double"},

    { "self_forwardmove", q2ai_AIself_forwardmove, METH_VARARGS, 
      "self_forwardmove(double)->null"},
    { "self_sidemove", q2ai_AIself_sidemove, METH_VARARGS, 
      "self_sidemove(double)->null"},
    { "self_upmove", q2ai_AIself_upmove, METH_VARARGS, 
      "self_upmove(double)->null"},
    { "self_attack", q2ai_AIself_attack, METH_VARARGS, 
      "self_attack(int)->null"},
 
    { "self_yawmove", q2ai_AIself_yawmove, METH_VARARGS, 
      "self_yawmove(double)->null"},
    { "self_setyaw", q2ai_AIself_setyaw, METH_VARARGS, 
      "self_setyaw(double)->null"},
    { "self_yaw", q2ai_AIself_yaw, METH_VARARGS, 
      "self_yaw()->double"},	  
    { "self_pitchmove", q2ai_AIself_pitchmove, METH_VARARGS, 
      "self_pitchmove(double)->null"},
    { "self_setpitch", q2ai_AIself_setpitch, METH_VARARGS, 
      "self_setpitch(double)->null"},
    { "self_pitch", q2ai_AIself_pitch, METH_VARARGS, 
      "self_pitch()->double"},

    { "entity_exists", q2ai_AIentity_exists, METH_VARARGS, 
      "entity_exists(int)->int"},
    { "entity_model", q2ai_AIentity_model, METH_VARARGS, 
      "entity_model(int)->string"},

    { "entity_x", q2ai_AIentity_x, METH_VARARGS, 
      "entity_x(int)->double"},
    { "entity_y", q2ai_AIentity_y, METH_VARARGS, 
      "entity_y(int)->double"},
    { "entity_z", q2ai_AIentity_z, METH_VARARGS, 
      "entity_z(int)->double"},
    { "entity_pitch", q2ai_AIentity_pitch, METH_VARARGS, 
      "entity_pitch(int)->double"},
    { "entity_yaw", q2ai_AIentity_yaw, METH_VARARGS, 
      "entity_yaw(int)->double"},
    { "entity_frame", q2ai_AIentity_frame, METH_VARARGS, 
      "entity_frame(int)->int"},


    { "view_width", q2ai_AIview_width, METH_VARARGS, 
      "view_width()->int"},
    { "view_height", q2ai_AIview_height, METH_VARARGS, 
      "view_height()->int"},
    { "view_pixel", q2ai_AIview_pixel, METH_VARARGS, 
      "view_pixel(int, int)->int"},
    { "view_block", q2ai_AIview_block, METH_VARARGS, 
      "view_block(int, int, int, int)->int"},

    { "red", q2ai_red, METH_VARARGS, 
      "red(int)->int"},
    { "green", q2ai_green, METH_VARARGS, 
      "green(int)->int"},
    { "blue", q2ai_blue, METH_VARARGS, 
      "blue(int)->int"},

    { "talk", q2ai_AI_talk, METH_VARARGS, 
      "talk(string)->null"},
    { "teamtalk", q2ai_AI_teamtalk, METH_VARARGS, 
      "teamtalk(string)->null"},

    { "command", q2ai_AI_command, METH_VARARGS, 
      "command(string)->null"},
    { "msg_body", q2ai_AImsg_body, METH_VARARGS, 
      "msg_body(int)->string"},
    { "msg_type", q2ai_AImsg_type, METH_VARARGS, 
      "msg_type(int)->int"},


    { "anglediff", q2ai_anglediff, METH_VARARGS, 
      "anglediff(double, double)->double"},
    { "angleadd", q2ai_angleadd, METH_VARARGS, 
      "angleadd(double, double)->double"},

    { "dist", q2ai_dist, METH_VARARGS, 
      "dist(double, double, double, double)->double"},
    { "xdir", q2ai_xdir, METH_VARARGS, 
      "xdir(double, double, double, double)->double"},
    { "rad", q2ai_rad, METH_VARARGS, 
      "rad(double)->double"},
    { "deg", q2ai_deg, METH_VARARGS, 
      "deg(double)->double"},

	{ "trace", q2ai_trace, METH_VARARGS,
	  "trace(float, float, float, float, float, float, float)->null"},
	{ "traced_endpoint_x", q2ai_traced_endpoint_x, METH_VARARGS,
	  "traced_endpoint_x()->float"},
	{ "traced_endpoint_y", q2ai_traced_endpoint_y, METH_VARARGS,
	  "traced_endpoint_y()->float"},
	{ "traced_endpoint_z", q2ai_traced_endpoint_z, METH_VARARGS,
	  "traced_endpoint_z()->float"},
	{ "traced_fraction", q2ai_traced_fraction, METH_VARARGS,
	  "traced_fraction()->float"},

    { "set_AImain", q2ai_set_AImain, METH_VARARGS, 
      "set_AImain(int)->null"},
    { "call_AImain", q2ai_call_AImain, METH_VARARGS, 
      "call_AImain()->null"},
	  
    {NULL,NULL}
};



void AI_main (void) {

	PyEval_CallObject(AImain_callback, NULL);
	if (PyErr_Occurred() != NULL)
		PyErr_Print();
	
	return;
}


extern void initq2ai(void)
{
     Py_InitModule4(
            "q2ai",   // name of the module
            q2aiMethods,  // name of the method table
            "Quake2AI", // doc string for module
            0,   // last two never change
            PYTHON_API_VERSION);
    return;
}

